var TOSTimer = 150000;
var TNGTimer = 300000;
var decimalsOnScreen = 1;
var prefixOnScreen = false;

function initVars() {
	TOSTimer = localStorage.getItem("TOSTimer");
	TNGTimer = localStorage.getItem("TNGTimer");
	decimalsOnScreen = localStorage.getItem("decimalsOnScreen");
	prefixOnScreen = localStorage.getItem("prefixOnScreen");

	if (TOSTimer == null) { TOSTimer = 150000; }
	if (TNGTimer == null) { TNGTimer = 300000; }
	if (decimalsOnScreen == null) { decimalsOnScreen = 1; }
	if (prefixOnScreen == null) { prefixOnScreen = false; }

	TOSTimer = parseInt(TOSTimer);
	TNGTimer = parseInt(TNGTimer);
	decimalsOnScreen = parseInt(decimalsOnScreen);
	if (prefixOnScreen === "true") {
		prefixOnScreen = true;
	}
	else {
		prefixOnScreen = false;
	}

	if (prefixOnScreen == true) {
		SDprefix.innerHTML = "ON";
	}
	else {
		SDprefix.innerHTML = "OFF";
	}
	Decimals.innerHTML = decimalsOnScreen;
}

function saveVars() {
	localStorage.setItem("TOSTimer", TOSTimer);
	localStorage.setItem("TNGTimer", TNGTimer);
	localStorage.setItem("decimalsOnScreen", decimalsOnScreen);
	localStorage.setItem("prefixOnScreen", prefixOnScreen);
}

function trunk(num, fixed) {
    var re = new RegExp('^-?\\d+(?:\.\\d{0,' + (fixed || -1) + '})?');
    return num.toString().match(re)[0];
}

function togglePrefix() {
	if (prefixOnScreen == false) {
		clearTimeout(TOSTimeout);
		clearTimeout(TNGTimeout);
		prefixOnScreen = true;
		SDprefix.innerHTML = "ON";
		computeSD('TOS', TOSTimer);
		computeSD('TNG', TNGTimer);
	}
	else {
		prefixOnScreen = false;
		clearTimeout(TOSTimeout);
		clearTimeout(TNGTimeout);
		SDprefix.innerHTML = "OFF";
		computeSD('TOS', TOSTimer);
		computeSD('TNG', TNGTimer);
	}
	saveVars();
}

function decimalsPlus() {
	if (decimalsOnScreen < 4) {
		clearTimeout(TOSTimeout);
		clearTimeout(TNGTimeout);
		decimalsOnScreen = decimalsOnScreen + 1;
		Decimals.innerHTML = decimalsOnScreen;
		TOSTimer = TOSTimer / 10;
		TNGTimer = TNGTimer / 10;
		computeSD('TOS', TOSTimer);
		computeSD('TNG', TNGTimer);
	}
	saveVars();
}

function decimalsMinus() {
	if (decimalsOnScreen > 0) {
		clearTimeout(TOSTimeout);
		clearTimeout(TNGTimeout);
		decimalsOnScreen = decimalsOnScreen - 1;
		Decimals.innerHTML = decimalsOnScreen;
		TOSTimer = TOSTimer * 10;
		TNGTimer = TNGTimer * 10;
		computeSD('TOS', TOSTimer);
		computeSD('TNG', TNGTimer);
	}
	saveVars();
}

// SDtype is TOS, TNG or Both - actually anything else TPS or 
// TNG computes both.
function computeSD(SDtype, SDtimer) {

	decimals = decimalsOnScreen;

	prefixSDDisplay = prefixOnScreen;

	timeNow = new Date();

	timeNowMilli = timeNow.getTime();

	// UTC correction
	diffUTCTime = timeNow.getTimezoneOffset() * 60000;
	timeNowMilli = timeNowMilli + diffUTCTime;
			
	// ** Common **
	// millsecInQCYear is the number of milliseconds in 
	// a standard quadcent year.
	millisecInQCYear = 31556952000;
		
	// millisecInYear is the number of milliseconds in
	// a gregorian year.
	millisecInYear = 31536000000;

	if (SDtype != "TOS") {
		// ** TNG style SD **

		// prefixSDTNGZero is the starting prefix for TNG style
		// stardates, which is [21] 00000.00.
		prefixSDTNGZero = 21;

		// timeSDTNGZero is the date when the TNG style stardates
		// begin, january 1st, 2323. It is a date coinciding in
		// both quadcent and gregorian calendars.
		timeSDTNGZero = new Date(2323,0,1);
		timeSDTNGZeroMilli = timeSDTNGZero.getTime();

		// Compute the time difference between reference and now.
		timeBetweenTNG = timeNowMilli - timeSDTNGZeroMilli;

		// rawSDTNG is not really a SD since it's prefix and SD 
		// difference concatenated. The formula is simple:
		// 1000 SD units == 1 quadcent year, 
		// 1 quadcentyear == 31556952 seconds,
		// so SD value for the difference is:
		rawSDTNG = timeBetweenTNG * 1000 / millisecInQCYear;

		// refinedSDTNG is the real SD value.
		// As rawSDTNG is a difference, if rawSDTNG is positive
		// the real SD value is the modulo , if rawSDTNG is
		// negative, 100000 is added to the modulo, as rawSDTNG is a
		// difference (and is the complement to 100000 of
		// the real SD). 
		if (rawSDTNG < 0)
			refinedSDTNG = 100000 + rawSDTNG % 100000;
		else
			refinedSDTNG = rawSDTNG % 100000
		displaySDTNG = trunk(refinedSDTNG, decimals);
				
		// Fills up empty zeroes if the SD is less than 5 digits.
		if (refinedSDTNG >=10000)
			displaySDTNGString = displaySDTNG;
		else
		if (refinedSDTNG < 10)
			displaySDTNGString = "0000" + displaySDTNG;
		else
		if (refinedSDTNG < 100)
			displaySDTNGString = "000" + displaySDTNG;
		else
		if (refinedSDTNG < 1000)
			displaySDTNGString = "00" + displaySDTNG;
		else
		if (displaySDTNG < 10000)
			displaySDTNGString = "0" + displaySDTNG;

		// diffPrefixSDTNG is the difference in the SD prefix.
		diffPrefixSDTNG = Math.floor(rawSDTNG / 100000);

		// The real SD prefix.
		prefixSDTNG = prefixSDTNGZero + diffPrefixSDTNG;

		// The SD string.
		if (prefixSDDisplay == true)
			SDTNG.innerHTML = "[" + prefixSDTNG + "]" + displaySDTNGString;
		else
			SDTNG.innerHTML = displaySDTNGString;
		if (SDtimer != "")
			TOSTimeout = setTimeout(function() { computeSD('TOS') }, SDtimer);
	}

	if (SDtype != "TNG") {
		// ** TOS style SD **

		// timeSDTOSZeroMilli is the date when the TOS style stardates
		// begin, january 4th, 2162. 
		timeSDTOSZero = new Date(2162,0,4)
		timeSDTOSZeroMilli = timeSDTOSZero.getTime()

		// Compute the time difference between reference and now.
		timeBetweenTOS = timeNowMilli - timeSDTOSZeroMilli;

		// rawSDTOS is not a SD either since it's prefix and SD 
		// difference concatenated (as in TNG style). The formula is 
		// similar:
		// 5 SD units == 1 day,
		// => 1825 SD units == 1 year, 
		// 1 year == 31536000 seconds,
		// so SD value for the difference is:
		rawSDTOS = timeBetweenTOS * 1825 / millisecInYear;

		// refinedSDTOS is the real SD value.
		// As rawSDTOS is a difference, if rawSDTOS is positive
		// the real SD value is the modulo , if rawSDTOS is
		// negative, 10000 is added to the modulo, as rawSDTOS is a
		// difference (and is the complement to 10000 of
		// the real SD). 
		if (rawSDTOS < 0)
			refinedSDTOS = 10000 + rawSDTOS % 10000;
		else
			refinedSDTOS = rawSDTOS % 10000;
					
		displaySDTOS = trunk(refinedSDTOS, decimals);

		// Fills up empty zeroes if the SD is less than 4 digits.
		if (refinedSDTOS >=1000)
			displaySDTOSString = displaySDTOS;
		else
		if (refinedSDTOS < 10)
			displaySDTOSString = "000" + displaySDTOS;
		else
		if (refinedSDTOS < 100)
			displaySDTOSString = "00" + displaySDTOS;
		else
		if (refinedSDTOS < 1000)
			displaySDTOSString = "0" + displaySDTOS;

		// prefixSDTOS is the difference in the SD prefix, and actually
		// the real prefix, since the initial prefix is 0.
		prefixSDTOS = Math.floor(rawSDTOS / 10000);

		// The SD string.
		if (prefixSDDisplay == true)
			SDTOS.innerHTML = "[" + prefixSDTOS + "]" + displaySDTOSString;
		else
			SDTOS.innerHTML = displaySDTOSString;
		if (SDtimer != "")
			TNGTimeout = setTimeout(function() { computeSD('TNG') }, SDtimer);
		}
}
